;
; AutoIt Version: 3.0
; Language:       Franglais
; Platform:       Win NT / XP
; Author:         AvvA
;
; Script Function:
;   Prepare the Wan/Stunnel/HFS link, and create the certificate & key to use HTTPS certificate.
;   ! Require at least one confmakr.lng !

#include "confmakr.lng"
#include <GuiConstantsEx.au3>
#include <ButtonConstants.au3>

; GUI
$gui = GuiCreate($lang_gui_title, 330, 440)
;GuiSetIcon(@ScriptDir & "\sHFS\stunnel\stunnel.exe", 0)

; BUTTONS
$btn_makeall = GUICtrlCreateButton("1", 10, 405, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 7)
GUICtrlSetTip(-1, $lang_btn_makefiles_tip)
$btn_launchquit = GUICtrlCreateButton("2", 245, 405, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, @ScriptDir & "\sHFS\stunnel\stunnel.exe", 0)
GUICtrlSetTip(-1, $lang_btn_launchquit_tip)
$btn_quit = GUICtrlCreateButton("3", 285, 405, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 28)
GUICtrlSetTip(-1, $lang_btn_quit)
;$btn_test = GuiCtrlCreateButton("test", 150, 420)

$tab = GUICtrlCreateTab(0, 0, 330, 405)

$tab_openssl = GUICtrlCreateTabItem($lang_tab_certificat)

GUICtrlCreateLabel($lang_cert_info, 15,40,300,120)

; Informations basiques
GuiCtrlCreateLabel($lang_certificat_title, 5, 190, 330)
GUICtrlSetFont(-1, 8.5, 600, 4)
GuiCtrlCreateLabel($lang_cert_C, 5, 210)
$cert_C = GuiCtrlCreateInput("", 150, 210, 24, 18)
GuiCtrlCreateLabel($lang_cert_ST, 5, 230)
$cert_ST = GuiCtrlCreateInput("", 150, 230, 150, 18)
GuiCtrlCreateLabel($lang_cert_L, 5, 250)
$cert_L = GuiCtrlCreateInput("", 150, 250, 150, 18)
GuiCtrlCreateLabel($lang_cert_O, 5, 270)
$cert_O = GuiCtrlCreateInput("", 150, 270, 150, 18)
GuiCtrlCreateLabel($lang_cert_OU, 5, 290)
$cert_OU = GuiCtrlCreateInput("", 150, 290, 150, 18)
GuiCtrlCreateLabel($lang_cert_CN, 5, 310)
$cert_CN = GuiCtrlCreateInput("", 150, 310, 150, 18)
$btn_fillurl = GuiCtrlCreateButton($lang_cert_CN_btn, 302, 311, 16, 16)
GuiCtrlSetTip(-1, $lang_cert_CN_btn_tip)


$tab_HFS = GUICtrlCreateTabItem($lang_tab_hfstun)

;GuiCtrlCreateLabel("IP publique :", 5, 25)
$ext_ip = GuiCtrlCreateInput("", 5, 35, 100, 18)
GuiCtrlSetTip(-1, $lang_hfs_extip_tip)
$get_ext_ip = GuiCtrlCreateButton($lang_hfs_extip_get, 110, 34, 125, 20)
GuiCtrlSetTip(-1, $lang_hfs_extip_get_tip)
$get_ip_alt = GuiCtrlCreateButton($lang_hfs_extip_get_alt, 238, 34, 70, 20)
GuiCtrlSetTip(-1, $lang_hfs_extip_get_alt_tip)

GuiCtrlCreateLabel($lang_hfs_ip, 5, 65)
;trouver le loopback
$hfs_ip = GuiCtrlCreateInput($lang_hfs_ip_input, 5, 80, 100, 18)
GuiCtrlSetTip(-1, $lang_hfs_ip_input_tip)
GuiCtrlCreateLabel(":", 106, -1)
$hfs_port = GuiCtrlCreateInput($lang_hfs_port_input, 109, -1, 60, 18)
GuiCtrlSetTip(-1, $lang_hfs_port_input_tip)

GuiCtrlCreateLabel($lang_stun_listenip, 5, 105)
$stunout_ip = GuiCtrlCreateInput($lang_stun_listenip_input, 5, 120, 100, 18)
GuiCtrlSetTip(-1, $lang_stun_listenip_input_tip)
GuiCtrlCreateLabel(":", 106, -1)
$stunout_port = GuiCtrlCreateInput($lang_stun_listenport_input, 109, -1, 60, 18)
GuiCtrlSetTip(-1, $lang_stun_listenport_input_tip)

;separator options relatives  hfs

$cb_hfs_stunlog = GUICtrlCreateCheckbox($lang_cb_hfs_stunlog, 5, 140, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_stunlog_tip)
GUICtrlSetState(-1, 1)
$cb_hfs_https = GUICtrlCreateCheckbox($lang_cb_hfs_https, 5, 160, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_https_tip)
GUICtrlSetState(-1, 1)
$cb_hfs_dont_incl_port = GUICtrlCreateCheckbox($lang_cb_hfs_dont_incl_port, 5, 180, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_dont_incl_port_tip)
GUICtrlSetState(-1, 1)

$cb_hfs_browse_localhost = GUICtrlCreateCheckbox($lang_cb_hfs_browse_localhost, 5, 200, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_browse_localhost_tip)

$cb_hfs_dont_find_extip = GUICtrlCreateCheckbox($lang_cb_hfs_dont_find_extip, 5, 220, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_dont_find_extip_tip)
GUICtrlSetState(-1, 1)
$cb_hfs_dont_search_betterip = GUICtrlCreateCheckbox($lang_cb_hfs_dont_search_betterip, 5, 240, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_dont_search_betterip_tip)
GUICtrlSetState(-1, 1)

$cb_hfs_saveopt_onexit = GUICtrlCreateCheckbox($lang_cb_hfs_saveopt_onexit, 5, 260, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_saveopt_onexit_tip)

;separator avanc

$hfsip = GUICtrlRead($hfs_ip)
$cb_hfs_listenon = GUICtrlCreateCheckbox($lang_cb_hfs_listenon, 5, 280, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_listenon_tip)
GUICtrlSetState(-1, 1)

$cb_local = GUICtrlCreateCheckbox($lang_cb_local, 5, 300, -1, 20)
$local_net_label = GuiCtrlCreateLabel($lang_localnet_label, 5, 322)
$local_network = GuiCtrlCreateInput("", 80, 320, 100, 18)
GuiCtrlSetTip(-1, $lang_localnet_input_tip)
$local_ip_label = GuiCtrlCreateLabel($lang_localip_label, 5, 342)
$local_ip = GuiCtrlCreateInput("", 80, 340, 100, 18)
GuiCtrlSetTip(-1, $lang_localip_input_tip)

$cb_hfs_ban_all = GUICtrlCreateCheckbox($lang_cb_hfs_banall, 5, 360, -1, 20)
GuiCtrlSetTip(-1, $lang_cb_hfs_banall_tip)
GUICtrlSetState(-1, 1)
$cb_hfs_ban_noreply = GUICtrlCreateCheckbox($lang_cb_hfs_ban_noreply, 5, 380, -1, -1)
GuiCtrlSetTip(-1, $lang_cb_hfs_ban_noreply_tip)
GUICtrlSetState(-1, 1)


;;$tab_graph = GUICtrlCreateTabItem("Visuel")
;adresse rseau (ip sur le rseau)
;Votre rseau local -switch- votre ordinateur
;;$localnetwork = GUICtrlRead($local_network)
;;$gr_label_localnet = GuiCtrlCreateLabel("Rseau local : " & $localnetwork, 10, 10)
;votre ordinateur (loopback et localnetwork ip)
;;$gr_label_loopback = GuiCtrlCreateLabel("Boucle locale : " & $grlabeloopback, 10, 10)
;loopback -> HFS -> lien stunnel
;suivant la coche-> rseau local
;loopback -> stunnel -> firewall -> www ou passerelle (accepte d'abord l'ip externe relle puis continue avec la passerelle)
;?routeur ou box en mode routeur? (adresse de la passerelle)
;Votre box FAI (IP publique)
;fleche
;www dessin plante
;fleche
;Vos amis


$tab_about = GUICtrlCreateTabItem($lang_tab_about)
GUICtrlCreateLabel($lang_tab_about_intro,15,35,300,40)
$btn_link_sHFS = GUICtrlCreateButton($lang_btn_link_sHFS,110,76,-1,-1)
;thanks links
GUICtrlCreateLabel($lang_thanks_links_label,15,115,-1,20)
$btn_link_hfs = GUICtrlCreateButton($lang_btn_link_hfs_noimage, 20, 135, 36, 36, $BS_ICON)
GUICtrlSetImage(-1, @ScriptDir & "\sHFS\hfs.exe", 0)
GUICtrlSetTip(-1, $lang_btn_link_hfs_tip)
$btn_link_openssl = GUICtrlCreateButton($lang_btn_link_openssl_noimage, 63, 145, -1, -1)
$btn_link_stunnel = GUICtrlCreateButton($lang_btn_link_stunnel_noimage, 178, 135, 36, 36, $BS_ICON)
GUICtrlSetImage(-1, @ScriptDir & "\sHFS\stunnel\stunnel.exe", 0)
GUICtrlSetTip(-1, $lang_btn_link_stunnel_noimage_tip)

GUICtrlCreateLabel($lang_link_tuto_label,15,190,-1,-1)
$btn_tuto_principal = GUICtrlCreateButton($lang_btn_tuto_principal, 20, 205, -1, -1)
$btn_tuto_stunlog = GUICtrlCreateButton($lang_btn_tuto_stunlog, 20, 230, -1, -1)

GUICtrlCreateLabel($lang_other_links,15,265,-1,-1)
$btn_hfs_beta = GUICtrlCreateButton($lang_hfs_beta_link,20,280,-1,-1)
$btn_tuto_filezilla = GUICtrlCreateButton($lang_tuto_filezilla_link, 20, 305, -1, -1)


$progression = guictrlcreatelabel("", 7, 345, 290, 55)


; FUNCTIONS

;this one is for testing purpose i comment uncomment it on need (require to uncomment the button at the top au this file, and the $msg = btn_test in the end loop).
;Func test()
;$cb_local_state = GUICtrlRead($cb_local)
;			msgbox(0, "test", $cb_local_state)
;			if $cb_local_state = $GUI_CHECKED then
;				GuiCtrlCreateLabel("Rseau local : ", 5, 80)
;				$local_ip = GuiCtrlCreateInput("", 5, 95, 100, 18)
;			endif
;EndFunc

; Create the key and certificate with openssl according to the first tab, and the external IP and listening port of STunnel on the second tab if the site adress isn't filled.
Func conf_key($cert_C, $cert_ST, $cert_L, $cert_O, $cert_OU, $cert_CN, $ext_ip, $stunout_port)
$certC = GUICtrlRead($cert_C)
$certST = GUICtrlRead($cert_ST)
$certL = GUICtrlRead($cert_L)
$certO = GUICtrlRead($cert_O)
$certOU = GUICtrlRead($cert_OU)
$certCN = GUICtrlRead($cert_CN)

if $certCN = "" then 
	$extip = GUICtrlRead($ext_ip)
	$extport = GUICtrlRead($stunout_port)
	$certCN = $extip & ":" & $extport
endif

$filecheck = FileExists(@ScriptDir & "\sHFS\stunnel\OpenSSL\bin\pem.conf")
if $filecheck = 1 then
	$ask_wtd = msgbox(4, $lang_warning, $lang_file_exist_pemconf & @CR & $lang_file_overwrite)
	if $ask_wtd = 7 then return "nopemconf"
Endif

$file = FileOpen(@ScriptDir & "\sHFS\stunnel\OpenSSL\bin\pem.conf", 2)
	If $file = -1 Then
		MsgBox(0, $lang_error, $lang_file_creation_error)
		Return "filerror"
	EndIf
	;$prepare = FileRead(@ScriptDir & "\pemconf.pre")
	$prepare = "RANDFILE = ./random.rnd" & @CRLF & @CRLF & "[ req ]" & @CRLF & "default_bits = 2048" & @CRLF & "encrypt_key = yes" & @CRLF & "distinguished_name = req_distinguished_name" & @CRLF & "x509_extensions = cert_type" & @CRLF & "prompt = no" & @CRLF & @CRLF & "[ req_distinguished_name ]" & @CRLF

	FileWrite($file, $prepare)
	if $certC <> "" then FileWriteLine($file, "C = " & $certC)
	if $certST <> "" then FileWriteLine($file, "ST = " & $certST)
	if $certL <> "" then FileWriteLine($file, "L = " & $certL)
	if $certO <> "" then FileWriteLine($file, "O = " & $certO)
	if $certOU <> "" then FileWriteLine($file, "OU = " & $certOU)
	if $certCN <> "" then FileWriteLine($file, "CN = " & $certCN)
	FileWriteLine($file, @CRLF & "[ cert_type ]" & @CRLF & "nsCertType = server")
FileClose($file)
ShellExecuteWait(@ScriptDir & "\sHFS\stunnel\OpenSSL\bin\openssl.exe", "req -new -x509 -days 3650 -nodes -config pem.conf -out ../../stunnel.pem -keyout ../../stunnel.pem", @ScriptDir & "\sHFS\stunnel\OpenSSL\bin", "open", @SW_HIDE)

$filecheck = FileExists(@ScriptDir & "\sHFS\stunnel\stunnel.pem")
if $filecheck = 1 then
	return "ok"
else
	return "stunnelpemfilerror"
Endif

EndFunc

; Create the stunnel.conf file
Func conf_stunnel($hfs_port, $hfs_ip, $stunout_ip, $stunout_port)
$hfsport = GUICtrlRead($hfs_port)
$hfsip = GUICtrlRead($hfs_ip)
$stunoutport = GUICtrlRead($stunout_port)
$stunoutip = GUICtrlRead($stunout_ip)

$filecheck = FileExists(@ScriptDir & "\sHFS\stunnel\stunnel.conf")
if $filecheck = 1 then
	$ask_wtd = msgbox(4, $lang_warning, $lang_file_exist_stunnelconf & @CR & $lang_file_overwrite)
	if $ask_wtd = 7 then return "nostunnelconf"
Endif

$stunfile = FileOpen(@ScriptDir & "\sHFS\stunnel\stunnel.conf", 2)
	If $stunfile = -1 Then
		MsgBox(0, $lang_error, $lang_file_creation_error)
		Return "filerror"
	EndIf
;$prepare = FileRead(@ScriptDir & "\stunnelconf.pre")
$prepare = "; Lines preceded with a ; are comments" & @CRLF & "; Empty lines are ignored" & @CRLF & "; For more options and details: see the manual (stunnel.html)" & @CRLF & @CRLF & "; File with certificate and private key" & @CRLF & "cert = stunnel.pem" & @CRLF & "key = stunnel.pem" & @CRLF & @CRLF & "; Log (1= minimal, 5=recommended, 7=all) and log file)" & @CRLF & "; Preceed with a ; to disable logging" & @CRLF & "debug = 6" & @CRLF & "output = ..\stunnel.log" & @CRLF & @CRLF & "; Some performance tuning" & @CRLF & "socket = l:TCP_NODELAY=1" & @CRLF & "socket = r:TCP_NODELAY=1" & @CRLF & @CRLF & "; Data compression algorithm: zlib or rle" & @CRLF & "compression = zlib" & @CRLF & @CRLF & "; SSL bug options / NO SSL:v2 (SSLv3 and TLSv1 is enabled)" & @CRLF & "options = ALL" & @CRLF & "options = NO_SSLv2" & @CRLF & @CRLF & "; Service-level configuration" & @CRLF & "; Stunnel listens to port 443 (HTTPS) to any IP" & @CRLF & "; and connects to port 44300 (HFS) on localhost" & @CRLF & "[https]" & @CRLF

	FileWrite($stunfile, $prepare)
	FileWriteLine($stunfile, "accept = " & $stunoutip & ":" & $stunoutport)
	FileWriteLine($stunfile, "connect = " & $hfsip & ":" & $hfsport)
	FileWriteLine($stunfile, "TIMEOUTclose = 0")
FileClose($stunfile)

return "ok"
EndFunc

; create or modify the hfs.events file.
Func conf_HFS_events($cb_hfs_stunlog)

$state_hfs_stunlog = GUICtrlRead($cb_hfs_stunlog)
if $state_hfs_stunlog = 1 then

	$filecheck = FileExists(@ScriptDir & "\sHFS\hfs.events")
	if $filecheck = 1 then
		$ask_wtd = msgbox(3, $lang_warning, $lang_file_exist_hfsevents & @CR & $lang_file_choice)
		if $ask_wtd = 2 then ;cancel : keep current
			return "nohfsevents"
		elseif $ask_wtd = 7 then ;no : mod current
			$filelog = FileOpen(@ScriptDir & "\sHFS\hfs.events", 1)
			If $filelog = -1 Then
				MsgBox(0, $lang_error, $lang_file_modif_error)
				return "hfseventsmoderror"
			Else
				FileWrite($filelog, @CRLF & @CRLF & "[connected]" & @CRLF & "{.add to log|{.load|stunnel.log|from={.^#stunnel.last.}.}{.set|#stunnel.last|{.filesize|stunnel.log.}.}|Clblue.}" & @CRLF & @CRLF & "[+start]" & @CRLF & "{.set|#stunnel.last|{.filesize|stunnel.log.}.}")
				FileClose($filelog)
			Return "hfseventsmod"
			Endif
		Endif
	Endif
	
	$filelog = FileOpen(@ScriptDir & "\sHFS\hfs.events", 2)
	If $filelog = -1 Then
		MsgBox(0, $lang_error, $lang_file_creation_error)
		return "hfseventscreaterror"
	Else
		FileWrite($filelog, "[connected]" & @CRLF & "{.add to log|{.load|stunnel.log|from={.^#stunnel.last.}.}{.set|#stunnel.last|{.filesize|stunnel.log.}.}|Clblue.}" & @CRLF & @CRLF & "[+start]" & @CRLF & "{.set|#stunnel.last|{.filesize|stunnel.log.}.}")
		FileClose($filelog)
	return "ok"
	Endif
	
EndIf
EndFunc

; create the hfs.ini
Func conf_HFS($hfs_port, $hfs_ip, $cert_CN, $stunout_port, $ext_ip, $cb_hfs_https, $cb_hfs_dont_incl_port, $cb_hfs_browse_localhost, $cb_hfs_dont_find_extip, $cb_hfs_dont_search_betterip, $cb_hfs_saveopt_onexit, $cb_hfs_listenon, $cb_local, $local_network, $cb_hfs_ban_all, $cb_hfs_ban_noreply)
$hfsport = GUICtrlRead($hfs_port)
$hfsip = GUICtrlRead($hfs_ip)
$certCN = GUICtrlRead($cert_CN)
$localnet = GUICtrlRead($local_network)

if $certCN = "" then 
	$extip = GUICtrlRead($ext_ip)
	$extport = ":" & GUICtrlRead($stunout_port)
	if $extport = ":443" then $extport = ""
	$certCN = $extip & $extport
endif

$state_hfs_https = GUICtrlRead($cb_hfs_https)
$state_hfs_dont_incl_port = GUICtrlRead($cb_hfs_dont_incl_port)
$state_hfs_dont_find_extip = GUICtrlRead($cb_hfs_dont_find_extip)
$state_hfs_dont_search_betterip = GUICtrlRead($cb_hfs_dont_search_betterip)
$state_hfs_saveopt_onexit = GUICtrlRead($cb_hfs_saveopt_onexit)
$state_hfs_listenon = GUICtrlRead($cb_hfs_listenon)
$state_hfs_ban_all = GUICtrlRead($cb_hfs_ban_all)
$state_hfs_ban_noreply = GUICtrlRead($cb_hfs_ban_noreply)
$state_cb_hfs_browse_localhost = GUICtrlRead($cb_hfs_browse_localhost)

$filecheck = FileExists(@ScriptDir & "\sHFS\hfs.ini")
if $filecheck = 1 then
	$ask_wtd = msgbox(4, $lang_warning, $lang_file_exist_hfsini & @CR & $lang_file_overwrite)
	if $ask_wtd = 7 then return "nohfsini"
Endif

$file = FileOpen(@ScriptDir & "\sHFS\hfs.ini", 2)
	If $file = -1 Then
		MsgBox(0, $lang_error, $lang_file_creation_error)
		Return "filerror"
	EndIf
	FileWriteLine($file, "HFS 2.3 beta - Build #242")
	FileWriteLine($file, "active=yes")
	FileWriteLine($file, "ip=" & $certCN)
	FileWriteLine($file, "custom-ip=" & $certCN)
	if $state_hfs_saveopt_onexit = 1 then FileWriteLine($file, "save-options-on-exit=yes")
	if $state_hfs_dont_incl_port = 1 then FileWriteLine($file, "dont-include-port-in-url=yes")
	FileWriteLine($file, "port=" & $hfsport)
	if $state_hfs_ban_noreply = 1 then FileWriteLine($file, "no-reply-ban=yes")
	if $state_hfs_https = 1 then FileWriteLine($file, "https-url=yes")
	if $state_hfs_dont_find_extip = 1 then FileWriteLine($file, "find-external-on-startup=no")
	if $state_hfs_dont_search_betterip = 1 then FileWriteLine($file, "search-better-ip=no")
	if $state_cb_hfs_browse_localhost = 1 then FileWriteLine($file, "browse-localhost=no")
	$state_cb_local = GUICtrlRead($cb_local)
	if $state_cb_local <> 1 AND $state_hfs_ban_all = 1 then
		FileWriteLine($file, "ban-list=\" & $hfsip & "#|")
		if $state_hfs_listenon = 1 then FileWriteLine($file, "listen-on=" & $hfsip)
	elseif $state_cb_local = 1 AND $state_hfs_ban_all = 1 then
		FileWriteLine($file, "ban-list=\" & $hfsip & ";" & $localnet & "#|")
	Endif
	FileClose($file)

return "ok"
EndFunc



; GUI MESSAGE LOOP
GuiSetState()

; here the endless loop to check if something checked, or a button clicked.
; we're a way from javascript and HTML "onclick", i'm still searching for an equivalent.
; this is why the tips can't stays a long time opened, i think...
Do
	$msg = GUIGetMsg()
	
if $msg <> "" then

	; red fields if both external IP and Domain name are empty
	$extip = GUICtrlRead($ext_ip)
	$certCN = GuiCtrlRead($cert_CN)	
	if $extip == "" AND $certCN == "" then
		ControlDisable($gui,"",$btn_makeall)
		GuiCtrlSetBkColor($ext_ip, 0xFF0000)
		GuiCtrlSetBkColor($cert_CN, 0xFF0000)
	else 
		ControlEnable($gui,"",$btn_makeall)
		GuiCtrlSetBkColor($ext_ip, 0xFFFFFF)
		GuiCtrlSetBkColor($cert_CN, 0xFFFFFF)
	endif

	; check local http state, and show/hide the IPs fields and enable/disable listening on one IP
	$cb_localnet_state = GUICtrlRead($cb_local)
	$which_tab = ControlCommand($gui, "", $tab, "CurrentTab", "")
	if $cb_localnet_state = 1 AND $which_tab = 2 then
		ControlShow($gui,"",$local_network)
		ControlShow($gui,"",$local_net_label)
		ControlShow($gui,"",$local_ip)
		ControlShow($gui,"",$local_ip_label)
		GuiCtrlSetState($cb_hfs_listenon, $GUI_UNCHECKED)
		GuiCtrlSetState($cb_hfs_listenon, $GUI_DISABLE)
	elseif $cb_localnet_state <> 1 AND $which_tab = 2 then
		ControlHide($gui,"",$local_network)
		ControlHide($gui,"",$local_net_label)
		ControlHide($gui,"",$local_ip)
		ControlHide($gui,"",$local_ip_label)
		GuiCtrlSetState($cb_hfs_listenon, 1)
		GuiCtrlSetState($cb_hfs_listenon, $GUI_ENABLE)
	endif
	
	Select
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop

		Case $msg = $btn_quit
			ExitLoop
			
		Case $msg = $btn_launchquit
			shellexecute(@ScriptDir & "\sHFS.exe")
			exitloop

		Case $msg = $get_ext_ip
			$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
			$oHTTP.Open("GET","http://www.showmyip.com/simple/")
			$oHTTP.Send()
			$HTMLtext = $oHTTP.Responsetext
			GuiCtrlSetData($ext_ip, $HTMLtext)
			
		Case $msg = $get_ip_alt
			ShellExecute("http://www.showmyip.com/simple/")
		
		Case $msg = $btn_fillurl
			$extip = GUICtrlRead($ext_ip)
			$extport = ":" & GUICtrlRead($stunout_port)
			if $extport = ":443" then $extport = ""
			$certCN = $extip & $extport
			GuiCtrlSetData($cert_CN, $certCN)

;		Case $msg = $btn_winxp_fw
;			ShellExecute("set allowedprogram " & @ScriptDir & "stunnel\stunnel.exe allow_stunnel ENABLE")

		Case $msg = $btn_link_sHFS
			ShellExecute("http://www.rejetto.com/forum/index.php?topic=7080.0")

		Case $msg = $btn_link_hfs
			ShellExecute("http://www.rejetto.com/hfs/")
		
		Case $msg = $btn_link_openssl
			ShellExecute("http://www.slproweb.com/products/Win32OpenSSL.html")			
		
		Case $msg = $btn_link_stunnel
			ShellExecute("http://www.stunnel.org/")		
		
		Case $msg = $btn_tuto_principal
			ShellExecute("http://www.rejetto.com/wiki/index.php/HFS:_Secure_your_server")		
		
		Case $msg = $btn_tuto_stunlog
			ShellExecute("http://www.rejetto.com/forum/index.php?topic=6651.msg1043256#msg1043256")		
		
		Case $msg = $btn_hfs_beta
			ShellExecute("http://www.rejetto.com/forum/index.php?board=33.0")		
		
		Case $msg = $btn_tuto_filezilla
			ShellExecute("http://www.rejetto.com/forum/index.php?topic=6651.msg1040766#msg1040766")
			
;		Case $msg = $btn_test
;			test()

		Case $msg = $btn_makeall
			ControlSetText("", "", $progression, "")
			$splash_message = $lang_progress & @LF
			GUICtrlSetState($tab_about,$GUI_SHOW)
			ControlSetText("", "", $progression, $splash_message)
			
			$conf_key_prog = conf_key($cert_C, $cert_ST, $cert_L, $cert_O, $cert_OU, $cert_CN, $ext_ip, $stunout_port)
			if $conf_key_prog = "ok" then 
				$splash_message &= $lang_prog_key_ok & @LF
			elseif $conf_key_prog = "nopemconf" then
				$splash_message &= $lang_prog_key_keep & @LF
			elseif $conf_key_prog = "stunnelpemfilerror" then
				$splash_message &= $lang_prog_key_openssl_error & @LF
			else
				$splash_message &= $lang_prog_key_error & @LF
			Endif
			ControlSetText("", "", $progression, $splash_message)

			$conf_HFSevents_prog = conf_HFS_events($cb_hfs_stunlog)
			if $conf_HFSevents_prog = "ok" then 
				$splash_message &= $lang_prog_hfsevents_ok
			elseif $conf_HFSevents_prog = "nohfsevents" then
				$splash_message &= $lang_prog_hfsevents_keep
			elseif $conf_HFSevents_prog = "hfseventsmod" then
				$splash_message &= $lang_prog_hfsevents_mod
			elseif $conf_HFSevents_prog = "hfseventsmoderror" then
				$splash_message &= $lang_prog_hfsevents_moderror
			elseif $conf_HFSevents_prog = "hfseventscreaterror" then
				$splash_message &= $lang_prog_hfsevents_createrror
			else
				$splash_message &= "- "
			Endif
			ControlSetText("", "", $progression, $splash_message)
			
			$conf_HFS_prog = conf_HFS($hfs_port, $hfs_ip, $cert_CN, $stunout_port, $ext_ip, $cb_hfs_https, $cb_hfs_dont_incl_port, $cb_hfs_browse_localhost, $cb_hfs_dont_find_extip, $cb_hfs_dont_search_betterip, $cb_hfs_saveopt_onexit, $cb_hfs_listenon, $cb_local, $local_network, $cb_hfs_ban_all, $cb_hfs_ban_noreply)
			if $conf_HFS_prog = "ok" then 
				$splash_message &= $lang_prog_hfsini_ok & @LF
			elseif $conf_HFS_prog = "nohfsini" then
				$splash_message &= $lang_prog_hfsini_keep & @LF
			else
				$splash_message &= $lang_prog_hfsini_error & @LF
			Endif
			ControlSetText("", "", $progression, $splash_message)
			
			$conf_stunnel_prog = conf_stunnel($hfs_port, $hfs_ip, $stunout_ip, $stunout_port)
			if $conf_stunnel_prog = "ok" then 
				$splash_message &= $lang_prog_stunnel_ok
			elseif $conf_stunnel_prog = "nostunnelconf" then
				$splash_message &= $lang_prog_stunnel_keep
			else
				$splash_message &= $lang_prog_stunnel_error
			Endif
			ControlSetText("", "", $progression, $splash_message)
			
	EndSelect
	
endif	
until $msg == $GUI_EVENT_CLOSE